package body MSHTML.HTMLControlElementEvents_Events is

   procedure Invoke
     (dispidMember : in Interfaces.C.long;
      wFlags       : in Interfaces.C.unsigned_short;
      pdispparams  : in GNATCOM.Types.Pointer_To_DISPPARAMS;
      Event_Object : in GNATCOM.Events.Event_Object.Event_Pointer)
   is
      use type Interfaces.C.long;
   begin
      case dispidMember is
         when HTMLControlElementEvents_onhelp=>
            onhelp
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onclick=>
            onclick
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_ondblclick=>
            ondblclick
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onkeypress=>
            onkeypress
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onkeydown=>
            onkeydown
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onkeyup=>
            onkeyup
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onmouseout=>
            onmouseout
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onmouseover=>
            onmouseover
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onmousemove=>
            onmousemove
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onmousedown=>
            onmousedown
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onmouseup=>
            onmouseup
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onselectstart=>
            onselectstart
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onfilterchange=>
            onfilterchange
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_ondragstart=>
            ondragstart
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onbeforeupdate=>
            onbeforeupdate
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onafterupdate=>
            onafterupdate
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onerrorupdate=>
            onerrorupdate
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onrowexit=>
            onrowexit
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onrowenter=>
            onrowenter
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_ondatasetchanged=>
            ondatasetchanged
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_ondataavailable=>
            ondataavailable
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_ondatasetcomplete=>
            ondatasetcomplete
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onlosecapture=>
            onlosecapture
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onpropertychange=>
            onpropertychange
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onscroll=>
            onscroll
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onfocus=>
            onfocus
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onblur=>
            onblur
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onresize=>
            onresize
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_ondrag=>
            ondrag
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_ondragend=>
            ondragend
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_ondragenter=>
            ondragenter
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_ondragover=>
            ondragover
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_ondragleave=>
            ondragleave
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_ondrop=>
            ondrop
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onbeforecut=>
            onbeforecut
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_oncut=>
            oncut
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onbeforecopy=>
            onbeforecopy
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_oncopy=>
            oncopy
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onbeforepaste=>
            onbeforepaste
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onpaste=>
            onpaste
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_oncontextmenu=>
            oncontextmenu
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onrowsdelete=>
            onrowsdelete
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onrowsinserted=>
            onrowsinserted
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_oncellchange=>
            oncellchange
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onreadystatechange=>
            onreadystatechange
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onbeforeeditfocus=>
            onbeforeeditfocus
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onlayoutcomplete=>
            onlayoutcomplete
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onpage=>
            onpage
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onbeforedeactivate=>
            onbeforedeactivate
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onbeforeactivate=>
            onbeforeactivate
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onmove=>
            onmove
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_oncontrolselect=>
            oncontrolselect
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onmovestart=>
            onmovestart
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onmoveend=>
            onmoveend
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onresizestart=>
            onresizestart
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onresizeend=>
            onresizeend
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onmouseenter=>
            onmouseenter
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onmouseleave=>
            onmouseleave
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onmousewheel=>
            onmousewheel
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onactivate=>
            onactivate
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_ondeactivate=>
            ondeactivate
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onfocusin=>
            onfocusin
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when HTMLControlElementEvents_onfocusout=>
            onfocusout
              (HTMLControlElementEvents_Event'Class (Event_Object.all));
         when others =>
            null;
      end case;
   end Invoke;

   function Create (From : in GNATCOM.Events.Event_Object.Event_Pointer)
     return GNATCOM.Create.COM_Interface.Pointer_To_COM_Interface_Type
   is
   begin
      return GNATCOM.Events.Event_Object.Create
        (Invoke'Access,
         IID_HTMLControlElementEvents,
         From);
   end Create;

   procedure Set_Events
     (This            : in out GNATCOM.Events.IConnectionPoint_Type;
      For_Object      : in     GNATCOM.IInterface.Interface_Type'Class;
      Event_Interface :
        access GNATCOM.Create.COM_Interface.COM_Interface_Type;
      Free            : Boolean := True)
   is
   begin
      GNATCOM.Events.Set_Events
        (This,
         For_Object,
         IID_HTMLControlElementEvents,
         Event_Interface,
         Free);
   end Set_Events;

   procedure onhelp
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onhelp;

   procedure onclick
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onclick;

   procedure ondblclick
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end ondblclick;

   procedure onkeypress
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onkeypress;

   procedure onkeydown
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onkeydown;

   procedure onkeyup
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onkeyup;

   procedure onmouseout
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onmouseout;

   procedure onmouseover
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onmouseover;

   procedure onmousemove
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onmousemove;

   procedure onmousedown
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onmousedown;

   procedure onmouseup
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onmouseup;

   procedure onselectstart
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onselectstart;

   procedure onfilterchange
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onfilterchange;

   procedure ondragstart
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end ondragstart;

   procedure onbeforeupdate
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onbeforeupdate;

   procedure onafterupdate
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onafterupdate;

   procedure onerrorupdate
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onerrorupdate;

   procedure onrowexit
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onrowexit;

   procedure onrowenter
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onrowenter;

   procedure ondatasetchanged
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end ondatasetchanged;

   procedure ondataavailable
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end ondataavailable;

   procedure ondatasetcomplete
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end ondatasetcomplete;

   procedure onlosecapture
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onlosecapture;

   procedure onpropertychange
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onpropertychange;

   procedure onscroll
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onscroll;

   procedure onfocus
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onfocus;

   procedure onblur
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onblur;

   procedure onresize
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onresize;

   procedure ondrag
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end ondrag;

   procedure ondragend
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end ondragend;

   procedure ondragenter
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end ondragenter;

   procedure ondragover
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end ondragover;

   procedure ondragleave
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end ondragleave;

   procedure ondrop
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end ondrop;

   procedure onbeforecut
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onbeforecut;

   procedure oncut
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end oncut;

   procedure onbeforecopy
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onbeforecopy;

   procedure oncopy
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end oncopy;

   procedure onbeforepaste
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onbeforepaste;

   procedure onpaste
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onpaste;

   procedure oncontextmenu
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end oncontextmenu;

   procedure onrowsdelete
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onrowsdelete;

   procedure onrowsinserted
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onrowsinserted;

   procedure oncellchange
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end oncellchange;

   procedure onreadystatechange
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onreadystatechange;

   procedure onbeforeeditfocus
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onbeforeeditfocus;

   procedure onlayoutcomplete
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onlayoutcomplete;

   procedure onpage
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onpage;

   procedure onbeforedeactivate
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onbeforedeactivate;

   procedure onbeforeactivate
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onbeforeactivate;

   procedure onmove
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onmove;

   procedure oncontrolselect
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end oncontrolselect;

   procedure onmovestart
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onmovestart;

   procedure onmoveend
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onmoveend;

   procedure onresizestart
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onresizestart;

   procedure onresizeend
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onresizeend;

   procedure onmouseenter
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onmouseenter;

   procedure onmouseleave
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onmouseleave;

   procedure onmousewheel
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onmousewheel;

   procedure onactivate
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onactivate;

   procedure ondeactivate
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end ondeactivate;

   procedure onfocusin
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onfocusin;

   procedure onfocusout
     (This : HTMLControlElementEvents_Event)
   is
   begin
      null;
   end onfocusout;

end MSHTML.HTMLControlElementEvents_Events;

